POJ 1329 Circle Through Three Points

2024-05-05 12:48
文章标签 poj 1329 three points circle

本文主要是介绍POJ 1329 Circle Through Three Points,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

链接:http://poj.org/problem?id=1329

题目:

Circle Through Three Points
Time Limit: 1000MS Memory Limit: 10000K
Total Submissions: 3176 Accepted: 1347

Description

Your team is to write a program that, given the Cartesian coordinates of three points on a plane, will find the equation of the circle through them all. The three points will not be on a straight line. 
The solution is to be printed as an equation of the form 
	(x - h)^2 + (y - k)^2 = r^2				(1)

and an equation of the form 
	x^2 + y^2 + cx + dy - e = 0				(2)

Input

Each line of input to your program will contain the x and y coordinates of three points, in the order Ax, Ay, Bx, By, Cx, Cy. These coordinates will be real numbers separated from each other by one or more spaces.

Output

Your program must print the required equations on two lines using the format given in the sample below. Your computed values for h, k, r, c, d, and e in Equations 1 and 2 above are to be printed with three digits after the decimal point. Plus and minus signs in the equations should be changed as needed to avoid multiple signs before a number. Plus, minus, and equal signs must be separated from the adjacent characters by a single space on each side. No other spaces are to appear in the equations. Print a single blank line after each equation pair.

Sample Input

7.0 -5.0 -1.0 1.0 0.0 -6.0
1.0 7.0 8.0 6.0 7.0 -2.0

Sample Output

(x - 3.000)^2 + (y + 2.000)^2 = 5.000^2
x^2 + y^2 - 6.000x + 4.000y - 12.000 = 0(x - 3.921)^2 + (y - 2.447)^2 = 5.409^2
x^2 + y^2 - 7.842x - 4.895y - 7.895 = 0

解题思路:

计算几何,模板题,关键就是求三角形的外心,

(x,y)为圆心坐标:

已知三个点的坐标是:(x1,y1),(x2,y2), (x3,y3);

A2 = x2 - x1, B2 = y2 - y1, A3 = x3 - x1, B3 = y3 - y1,C2 = (x2 * x2 - x1*x1 + y2 * y2 - y1 * y1), C3  = (x3 * x3 - x1 * x1 + y3 * y3 - y1 * y1);

x = (C2 * B3 - C3 * B2) / (B3 * A2 - A3 * B2) / 2;
y = (C2 * A3 - C3 * A2) / (B2 * A3 - B3 * A2) / 2;

r = sqrt((x - x1) * (x - x1) + (y - y1) * (y - y1));


代码:

#include <cstdio>
#include <cmath>
using namespace std;struct Point
{double x, y;
};Point a, b, c;
double x, y, r;void fun()
{double A2 = b.x - a.x, B2 = b.y - a.y;double C2 = b.y * b.y - a.y * a.y + b.x * b.x - a.x * a.x;double A3 = c.x - a.x, B3 = c.y - a.y;double C3 = c.y * c.y - a.y * a.y + c.x * c.x - a.x * a.x;x = (C2 * B3 - C3 * B2) / (B3 * A2 - A3 * B2) / 2;y = (C2 * A3 - C3 * A2) / (B2 * A3 - B3 * A2) / 2;r = sqrt((x - a.x) * (x - a.x) + (y - a.y) * (y - a.y));
}int main()
{while(~scanf("%lf%lf%lf%lf%lf%lf", &a.x, &a.y, &b.x, &b.y, &c.x, &c.y)){fun();printf("(x ");printf("%c", x > 0 ? '-' : '+');printf(" %.3f)^2 + (y ", fabs(x));printf("%c", y > 0 ? '-' : '+');printf(" %.3f)^2 = %.3f^2\n", fabs(y), r);printf("x^2 + y^2 ");printf("%c", -2 * x > 0 ? '+' : '-');printf(" %.3fx ", fabs(-2 * x));printf("%c", -2 * y > 0 ? '+' : '-');printf(" %.3fy ", fabs(-2 * y));printf("%c", x * x + y * y - r *r > 0 ? '+' : '-');printf(" %.3f = 0\n\n", fabs(x * x + y * y - r * r));}return 0;
}


这篇关于POJ 1329 Circle Through Three Points的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/961757

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i